/** 
 *   FIXME ....
 *
 *   (c) Copyright 2003 Federico Bareilles <fede@iar.unlp.edu.ar>,
 *   Instituto Argentino de Radio Astronomia (IAR).
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License as
 *   published by the Free Software Foundation; either version 2 of
 *   the License, or (at your option) any later version.
 *     
 *   The author does NOT admit liability nor provide warranty for any
 *   of this software. This material is provided "AS-IS" in the hope
 *   that it may be useful for others.
 *
 *   TODO: ???
 **/

#include <stdio.h>
#include <stdlib.h>
#include "encoders.h"
#include "iar.h"
#include "anemometer.h"



#define BUFFLEN 16

int main(int argc, const char *argv[]) 
{
	struct encoders_data ed;
	int ra = RA_CASE;
	int dec = DEC_CASE;
	int i;
	int anem[BUFFLEN], 
		sum = 0;

	if (encoders_open(ra, dec) == -1){
                perror("main");
                exit(1);
        }
	printf("The bufer legent is %d\n", encoders_buff_len());
	printf("e5850 is running: %d\n", encoders_is_running());
	//encoders_clear_buff();
	//getchar();
	for(i=0;i<BUFFLEN;i++) anem[i] = 0;
	i = 0;
	while(1) {
		if (encoders_get_next_data(&ed) == 1) {
//			printf("%5d %5d %5d\n", 
//			       ed.encoder[0], ed.encoder[1], ed.encoder[2]);
			sum -= anem[i];
			anem[i] = ed.anemometer;
			sum += anem[i];
			i++;
			if( i == BUFFLEN ) i = 0;
			printf("%5d %5d %3d %f\n", 
			       ed.encoder[0], ed.encoder[1], 
			       anemometer_conv( sum >>4),
			       (float)sum/(float)BUFFLEN);

		}else{
			printf("The bufer legent is %d\n", 
			       encoders_buff_len());
		}
	}

	encoders_stop();
	printf("e5850 is running: %d\n", encoders_is_running());

	encoders_close();

	return 0;
}



